# Getting Started

## Installing

Create a `.gitlab-ci.yml` file in the root of your project with the following
contents.

```yaml
include:
  - remote: https://gitlab.com/LibreFoodPantry/common-services/tools/pipeline/-/raw/main/source/gitlab-ci/pipeline.yml
```

Implement any of the following bash script commands that your project needs
and make them executable. See sections "Commands" and "Implementing a
Build Command" below for more information.

- `./commands/build.sh`
- `./commands/test.sh`
- `./commands/prepare-release.sh`

Commit and push the new files to your project.

```bash
chmod +x ./commands/*.sh
git add .gitlab-ci.yml ./commands
git update-index --chmod=+x ./commands/*.sh
git commit -m "ci: enable"
git push
```

## Configuring

Most behaviors in the pipeline can be modified by defining variables
in your `.gitlab-ci.yml` file.

```yaml
include:
  - remote: https://gitlab.com/LibreFoodPantry/common-services/tools/pipeline/-/raw/main/source/gitlab-ci/pipeline.yml

variables:
  # A comma separated list of jobs to disable.
  # For example: "test"
  # Valid jobs: build, test, and release.
  DISABLE_JOBS: ""

  # A comma separated list of jobs to enable.
  # For example: "test"
  # For valid jobs, see https://gitlab.com/LibreFoodPantry/common-services/tools/linters.
  ENABLE_JOBS: ""

  # The local name of the Docker image built by the build command and
  # tested by the test command. Ignored, if build doesn't produce an image.
  IMAGE_NAME: $CI_PROJECT_NAME:latest

  BUILD_COMMAND: ./commands/build.sh
  TEST_COMMAND: ./commands/test.sh
  PREPARE_RELEASE_COMMAND: ./commands/prepare-release.sh
```

## Commands

Roughly, the Pipeline knows ***when*** to build, test, and release your
project. But only the project knows the details of ***how*** to build, test,
and release it. A project provides these details to the Pipeline by creating
3 commands.

By default, the three commands are bash scripts and are located relative to
the project's root as follows:

- `./commands/build.sh`
- `./commands/test.sh`
- `./commands/prepare-release.sh`

If you want to use a different name or location, tell the Pipeline where they
are in your `.gitlab-ci.yml` file.

```yaml
variables:
    BUILD_COMMAND: ./commands/build.sh
    TEST_COMMAND: ./commands/test.sh
    PREPARE_RELEASE_COMMAND: ./commands/prepare-release.sh
```

`build.sh` builds the product produced by the project. So if the project
produces and Docker image, it builds that Docker image; if it produces a
specification in a yaml file, then it builds that yaml file. Any files
generated by this command that are not tracked by Git will be available
later to test and release. If build produces a Docker image named
`<project-name>:latest`, the build job will automatically push it to the
Project's container registry with and extension `:<branch>` for use by the
other jobs; that way they don't have to rebuild the image.

`test.sh` runs all of the automated tests, including unit, integration,
functional, and end-to-end tests. This command has access to any of the
files produced by build that are not tracked by Git. Any files that this
command generates that are not tracked by Git will be made available to
prepare-release.sh.

`prepare-release.sh` prepares any files for release. If your project only
produces a Docker image, then your project doesn't need this command. However,
if the project's product is a set of files that clients download (e.g., a
.jar file, a .yaml file, a .zip containing a static web-site, etc.) then
your project will provide this command. This command places the files to
release into `./artifacts/release` and then the Pipeline will do the rest.
This command is passed the new version number (e.g., `3.2.1`) as its first
command-line argument. This allows it to embed the new version number in
files it prepares.

## Runtime Environment

Commands run inside a Docker container built from the
[pipeline-base-image](https://gitlab.com/LibreFoodPantry/common-services/tools/pipeline-base-image).
That container is based on Docker's official image, which is based on Alpine
Linux, which means `docker` and `docker compose` are available. Additionally,
`Bash` and `Git` are installed and the container is associated with a full
Docker-in-Docker service, which means your project's command can use the
full capabilities of Docker (e.g., `docker build`, `docker run`,
`docker compose up`, etc.).

## Running Commands Locally

Developers on your project should regularly run the commands in their local
development environment. Ideally, to ensure repeatability and predictability,
they would be ran in an identical environment as that in the Pipeline.

As long as your development environment is Linux running Bash and has Docker
and Git installed, you're probably fine.

However, if you think something in your development environment is off, you
could run a command inside the pipeline-base-image.
The example below runs `build.sh` inside the `pipeline-base-image`.

```bash
docker run --rm -it \
 -v /var/run/docker.sock:/var/run/docker.sock \
 -v "$PWD:/project-name" -w /project-name \
 -u root \
 registry.gitlab.com/librefoodpantry/common-services/tools/pipeline-base-image \
 commands/build.sh
```

The second line makes your development environments Docker service available
to the container.
The third line maps the root of your project (the current working directory
`$PWD`) into the
container and sets its working directory to that directory.
The fourth line runs your script as root inside the container, otherwise it
can't make use of the outer docker environment.
The fifth line runs the pipeline-base-image. The sixth line runs the
`build.sh` command inside the image.

If you want to test out multiple commands, you can start an interactive bash
terminal
inside the base image and then run all the commands you like. Here is a
demonstration of
doing this (the `environment>` are command prompts indicating which
environment we are in;
you may not see the same prompts when you try this example).

```bash
local> docker run --rm -it \
 -v /var/run/docker.sock:/var/run/docker.sock \
 -v "$PWD:/project-name" -w /project-name \
 -u root \
 registry.gitlab.com/librefoodpantry/common-services/tools/pipeline-base-image \
 bash
pipeline-base-image> commands/build.sh
pipeline-base-image> commands/test.sh
pipeline-base-image> commands/prepare-release.sh
pipeline-base-image> exit
local>
```

### Running Linters Locally

Most projects will run multiple linters in their pipeline based on the types
of files contained in the project. It is good practice to run those linters
locally in your development environment so that you can correct linting
problems before pushing your changes to your branch and running the linters
in the pipeline.

There are three ways to do this:

1. Have your IDE run the linters for your project. Most IDEs will flag
problems as you type. Visual Studio Code does this with extensions. Each of
the
[linters that run in the LFP pipeline](https://gitlab.com/LibreFoodPantry/common-services/tools/linters)
will have information in its README on installing and configuring the
appropriate VS Code extension (if one exists).
2. Run the linter using its Docker image. Each of the
[linters that run in the LFP pipeline](https://gitlab.com/LibreFoodPantry/common-services/tools/linters)
will have information in its README on running the docker image locally.
3. Create a `lint.sh` command to run locally. If you have a large number of
linters that do not have VS Code extensions, rather than running each linter's
docker image individually, you may want to create a `lint.sh` command to run
all of the linters. You can combine the docker commands into a single file to
run them all.

## Implementing a Build Command

This section provides an example of implementing a build command. There
are different design options, and this section explores those options.
This will hopefully give you ideas about how to implement other commands.

WARNING: the code examples given in this section are sketches. They may
container bugs. If you find one, please let us know. Even if there are
no bugs, they may still not run because they are all fictitious examples.

The design of your project's commands should reflect the complexity of
the command. A build command that produces a Docker image is probably
one of the simplest build commands.

```bash
#!/usr/bin/env bash
docker build --tag project-name:latest ./source/
```

This assumes `source/` contains a Dockerfile and all the files it needs
are in `source/`. All the work of installing your application and its
dependencies are in that Dockerfile.

If your project produces something other than a Docker image, then you
should use an external Docker image/container to perform the command.

```bash
#!/usr/bin/env bash
docker run --rm \
    -v "$PWD:/project-name" -w "/project-name" \
    some.third.party.docker.image:latest
```

The details of that command depend on how the 3rd party image expects to
be used. Read its documentation for more information.

If building your project becomes complicated, requiring multiple 3rd party
tools, then you might want to create a separate builder container for your
project. The builder container would have all the build dependencies installed
and is able to do the work of building the project. Then your build command
would build and run the builder.

```bash
#!/usr/bin/env bash
docker build --tag builder:latest ./tools/builder/
docker run --rm \
    -v "$PWD:/project-name" -w "/project-name" \
    builder:latest
```

Locally this is pretty efficient. Docker will only rebuild the builder if
its source files have changed since the last time it was built. However,
the pipeline will have to rebuild it every time. To speed up the pipeline
you could create a separate builder project for your project, have it produce
a pre-built builder image preloaded with the build command, then override
the `build` job in `.gitlab-ci.yml`:

```yaml
build:
  image: url.to.builder.in.registry:latest
  variables:
    # tell the pipeline where the command is in your container
    BUILD_COMMAND: /builder/build.sh
```

This is an extension of the original build job; so it behaves just like
the original, but it uses a different image and build command. To ensure
that the original build job can run inside your project's builder image,
start your project's builder image based on the build job's image. So your
builder's Dockerfile would start as follows.

```Dockerfile
FROM registry.gitlab.com/librefoodpantry/common-services/tools/build:latest
```
